/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.40 by heimbach, Fri Nov 14 21:20:35 2003 UTC revision 1.62 by edhill, Thu Jan 15 19:19:59 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
86            
87      echo "test" > test      echo "test" > test
88      ln -s ./test link      ln -s ./test link
# Line 225  get_pdepend_list()  { Line 221  get_pdepend_list()  {
221    
222  #  Explain usage  #  Explain usage
223  usage()  {  usage()  {
224      echo  cat <<EOF
225      echo "Usage: "$0" [OPTIONS]"  
226      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
227      echo    where [OPTIONS] can be:
228      echo "    -help | --help | -h | --h"  
229      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
230      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
231      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
232      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
233      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
234      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
235      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
236      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
237      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
238      echo "    -makefile NAME | -mf NAME"  
239      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
240      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
241      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
242      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
243      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
244      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
245      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
246      echo "    -disable NAME | --disable NAME"  
247      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
248      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
249      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
250      echo "    -standarddirs NAME | --standarddirs NAME"            many platforms, "gmake" is the preferred choice.
251      echo "      -standarddirs=NAME | --standarddirs=NAME"  
252      echo "    -noopt NAME | --noopt NAME"      -makefile NAME | -mf NAME
253      echo "      -noopt=NAME | --noopt=NAME"        --makefile=NAME | -mf=NAME
254  #    echo "    -cpp NAME | --cpp NAME"            Call the makefile "NAME".  The default is "Makefile".
255  #    echo "      -cpp=NAME | --cpp=NAME"  
256      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
257      echo "      -fc=NAME | --fc=NAME"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
258      echo "    -[no]ieee | --[no]ieee"            Specify the location of the MITgcm ROOTDIR as "NAME".
259      echo "    -[no]mpi | --[no]mpi"            By default, genamke will try to find the location by
260      echo "    -[no]jam | --[no]jam"            looking in parent directories (up to the 5th parent).
261      echo  
262      echo "  and NAME is a string such as:"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
263      echo        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
264      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"            Here, "NAME" specifies a list of directories that are
265      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            used for additional source code.  Files found in the
266      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            "mods list" are given preference over files of the same
267      echo            name found elsewhere.
268      echo "  which, depending upon your shell, may need to be single-quoted"  
269      echo "  if it contains spaces, dashes, or other special characters."      -disable NAME | --disable NAME
270          -disable=NAME | --disable=NAME
271              Here "NAME" specifies a list of packages that we don't
272              want to use.  If this violates package dependencies,
273              genamke will exit with an error message.
274    
275        -enable NAME | --enable NAME
276          -enable=NAME | --enable=NAME
277              Here "NAME" specifies a list of packages that we wish
278              to specifically enable.  If this violates package
279              dependencies, genamke will exit with an error message.
280    
281        -standarddirs NAME | --standarddirs NAME
282          -standarddirs=NAME | --standarddirs=NAME
283              Here, "NAME" specifies a list of directories to be
284              used as the "standard" code.
285    
286        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
287          -fc=NAME | --fc=NAME
288              Use "NAME" as the fortran compiler.  By default, genmake
289              will search for a working compiler by trying a list of
290              "usual suspects" such as g77, f77, etc.
291    
292        -[no]ieee | --[no]ieee
293              Do or don't use IEEE numerics.  Note that this option
294              *only* works if it is supported by the OPTFILE that
295              is being used.
296    
297      While it is most often a single word, the "NAME" variables specified
298      above can in many cases be a space-delimited string such as:
299    
300        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
301        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
302        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
303    
304      which, depending upon your shell, may need to be single-quoted.
305    
306      For more detailed genmake documentation, please see:
307    
308        http://mitgcm.org/devel_HOWTO/
309    
310    EOF
311    
312      exit 1      exit 1
313  }  }
314    
# Line 293  WARNING: Please contact <MITgcm-support@ Line 331  WARNING: Please contact <MITgcm-support@
331  EOF  EOF
332          return 1          return 1
333      fi      fi
334      c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
335      RETVAL=$?      RETVAL=$?
336      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
337          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 323  WARNING: Please contact <MITgcm-support@ Line 361  WARNING: Please contact <MITgcm-support@
361  EOF  EOF
362          return 1          return 1
363      fi      fi
364      f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
365      RETVAL=$?      RETVAL=$?
366      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
367          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 399  EOF Line 437  EOF
437  }  }
438    
439    
440    check_netcdf_libs()  {
441        cat <<EOF > genmake_tnc.F
442          program fgennc
443    #include "netcdf.inc"
444          integer iret, ncid, xid
445          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
446          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
447          iret = nf_def_dim(ncid, 'X', 11, xid)
448          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
449          iret = nf_close(ncid)
450          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
451          end
452    EOF
453        $CPP genmake_tnc.F > genmake_tnc.f  \
454            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
455        RET_COMPILE=$?
456        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
457        RETVAL=$?
458        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
459            HAVE_NETCDF=t
460        else
461            cat genmake_tnc.log >> genmake_warnings
462        fi
463        rm -f genmake_tnc*
464    }
465    
466    
467  #  Set defaults here  #  Set defaults here
468  COMMANDL="$0 $@"  COMMANDL="$0 $@"
469    
# Line 407  LN= Line 472  LN=
472  S64=  S64=
473  KPP=  KPP=
474  FC=  FC=
475    CPP=
476  LINK=  LINK=
477  # DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
478  DEFINES=  DEFINES=
# Line 435  HAVE_SYSTEM= Line 501  HAVE_SYSTEM=
501  HAVE_FDATE=  HAVE_FDATE=
502  FC_NAMEMANGLE=  FC_NAMEMANGLE=
503  HAVE_CLOC=  HAVE_CLOC=
504    HAVE_NETCDF=
505    
506  MODS=  MODS=
507  TOOLSDIR=  TOOLSDIR=
508  SOURCEDIRS=  SOURCEDIRS=
509  INCLUDEDIRS=  INCLUDEDIRS=
510  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
511    
512  PWD=`pwd`  PWD=`pwd`
513  MAKE=make  MAKE=make
# Line 473  TAMC_EXTRA= Line 540  TAMC_EXTRA=
540    
541    
542  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
543  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
544  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
545    
546  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
547  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 491  gm_s12="TAF_EXTRA TAMC_EXTRA" Line 558  gm_s12="TAF_EXTRA TAMC_EXTRA"
558  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
559  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
560    
561    cat <<EOF
562    
563    GENMAKE :
564    
565    A program for GENerating MAKEfiles for the MITgcm project.  For a
566    quick list of options, use "genmake -h" or for more detail see:
567    
568      http://mitgcm.org/devel_HOWTO/
569    
570    EOF
571    
 echo  
572  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
573  gm_local="genmake_local"  gm_local="genmake_local"
574  for i in . $MODS ; do  for i in . $MODS ; do
# Line 546  for ac_option ; do Line 622  for ac_option ; do
622          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
623              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
624                    
625          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
626              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
627          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
628              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 571  for ac_option ; do Line 647  for ac_option ; do
647          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
648              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
649                    
650          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
651              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
652          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
653              PLATFORM=$ac_optarg ;;              echo
654                usage
655                ;;
656                    
657          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
658              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 601  for ac_option ; do Line 679  for ac_option ; do
679          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
680              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
681    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
682  #           -cpp | --cpp)  #           -cpp | --cpp)
683  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
684  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 621  for ac_option ; do Line 694  for ac_option ; do
694          -noieee | --noieee)          -noieee | --noieee)
695              IEEE= ;;              IEEE= ;;
696                    
697          -mpi | --mpi)  #       -jam | --jam)
698              MPI=true ;;  #           JAM=1 ;;
699          -nompi | --nompi)  #       -nojam | --nojam)
700              MPI= ;;  #           JAM=0 ;;
           
         -jam | --jam)  
             JAM=1 ;;  
         -nojam | --nojam)  
             JAM=0 ;;  
701                    
702          -ds | --ds)          -ds | --ds)
703              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 856  if test "x$HAVE_CLOC" != x ; then Line 924  if test "x$HAVE_CLOC" != x ; then
924  else  else
925      echo "no"      echo "no"
926  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
927  rm -f genmake_t*  rm -f genmake_t*
928    
929    echo -n "  Can we create NetCDF-enabled binaries...  "
930    check_netcdf_libs
931    if test "x$HAVE_NETCDF" != x ; then
932        echo "yes"
933    else
934        echo "no"
935    fi
936    
937    
938  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
939  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
# Line 909  fi Line 979  fi
979  if test "x$S64" = x ; then  if test "x$S64" = x ; then
980      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
981  fi  fi
982    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
983    
984  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
985    
# Line 923  if test -r $ROOTDIR"/eesupp/src/Makefile Line 994  if test -r $ROOTDIR"/eesupp/src/Makefile
994          rm -f make_eesupp.errors          rm -f make_eesupp.errors
995      else      else
996          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
997          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
998          exit 1          exit 1
999      fi      fi
1000  fi  fi
1001    
1002    #same for exch2
1003    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1004        echo "  Making source files in exch2 from  templates"
1005        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1006        RETVAL=$?
1007        if test "x${RETVAL}" = x0 ; then
1008            rm -f make_exch2.errors
1009        else
1010            echo "Error: problem encountered while building source files in exch2:"
1011            cat make_exch2.errors 1>&2
1012            exit 1
1013        fi
1014    fi
1015    
1016  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1017  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1018      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 960  rm -f ./.pd_tmp Line 1045  rm -f ./.pd_tmp
1045  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1046  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1047  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1048  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1049  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1050      for i in "." $MODS ; do      for i in "." $MODS ; do
1051          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 973  if test "x${PDEFAULT}" = x ; then Line 1058  if test "x${PDEFAULT}" = x ; then
1058      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1059  fi  fi
1060  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1061      echo "default packages file disabled"      echo "    default packages file disabled"
1062  else  else
1063      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1064          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1065      else      else
1066          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1067          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1068          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1069          RETVAL=$?          RETVAL=$?
# Line 1112  for i in $PACKAGES ; do Line 1196  for i in $PACKAGES ; do
1196      fi      fi
1197  done  done
1198    
1199    #  Build MNC templates and check for ability to build and use NetCDF
1200    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1201    RETVAL=$?
1202    if test "x$RETVAL" = x0 ; then
1203        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1204        RETVAL=$?
1205        if test "x${RETVAL}" = x0 ; then
1206            rm -f make_mnc.errors
1207        else
1208            echo "Error: problem encountered while building source files in pkg/mnc:"
1209            cat make_mnc.errors 1>&2
1210            exit 1
1211        fi
1212        if test -a "x$HAVE_NETCDF" != xt ; then
1213            cat <<EOF
1214    
1215  # Create a list of #define and #undef to enable/disable packages  WARNING: the "mnc" package has been enabled but tests failed to
1216  PACKAGES_DOT_H=PACKAGES_CONFIG.h    compile and/or execute NetCDF applications.  Please check that:
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
1217    
1218  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1219      2) the LIBS variable (within the 'optfile") specifies the correct
1220           NetCDF library to link against.
1221      
1222  EOF  EOF
1223        fi
1224    fi
1225    
1226    # Create a list of #define and #undef to enable/disable packages
1227    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1228  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1229  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1230  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1231  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1232  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1233  all_pack=  all_pack=
1234    DISABLED_PACKAGES=
1235  for n in $names ; do  for n in $names ; do
1236      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1237          has_pack="f"          has_pack="f"
# Line 1144  for n in $names ; do Line 1243  for n in $names ; do
1243          done          done
1244          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1245              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1246              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1247          fi          fi
1248      fi      fi
1249  done  done
1250  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1251  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1252      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1253      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1254  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1255    
1256  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1257      case $i in      case $i in
1258          aim_v23)          aim_v23)
1259              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1260              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1261              ;;              ;;
1262      esac      esac
1263  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1264    
1265  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1266    
1267  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1268  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1269  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1270      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1271  fi  fi
1272  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1273      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1274      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1275          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1276          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1277          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1278      else              exit 1
1279          SOURCEDIRS="$SOURCEDIRS $adr"          else
1280      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1281      adr="$ROOTDIR/$d/inc"          fi
1282      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1283          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1284          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1285          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1286      else              exit 1
1287          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1288      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1289  done          fi
1290        done
1291    fi
1292    
1293  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1294  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1295  CPP_OPTIONS=  CPP_OPTIONS=
1296    CPP_EEOPTIONS=
1297  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1298    names=`ls -1 "$ROOTDIR/pkg"`
1299  for i in $spaths ; do  for i in $spaths ; do
1300      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1301      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1302          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1303          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1304          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1305            for n in $names ; do
1306                test_for_package_in_cpp_options $CPP_OPTIONS $n
1307            done
1308        fi
1309        try="$i/CPP_EEOPTIONS.h"
1310        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1311            echo "    found CPP_EEOPTIONS=\"$try\""
1312            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1313    #**** not yet enabled ****
1314    #        test_for_mpi_in_cpp_eeoptions $try
1315    #**** not yet enabled ****
1316            CPP_EEOPTIONS="$try"
1317      fi      fi
1318  done  done
1319  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1320      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1321      exit 1      exit 1
1322  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1323    
1324  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1325  #  compiler.  #  compiler.
# Line 1247  for i in $SOURCEDIRS ; do Line 1334  for i in $SOURCEDIRS ; do
1334      done      done
1335  done  done
1336    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1337    
1338  echo  echo
1339  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1288  for d in $alldirs ; do Line 1364  for d in $alldirs ; do
1364      for sf in $sfiles ; do      for sf in $sfiles ; do
1365          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1366              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1367                    case $d/$sf in
1368                      ./$PACKAGES_DOT_H)
1369                            ;;
1370                      ./AD_CONFIG.h)
1371                            ;;
1372                      ./FC_NAMEMANGLE.h)
1373                            ;;
1374                      *)
1375                            touch .links.tmp/$sf
1376                            deplist="$deplist $sf"
1377                            ;;
1378                    esac
1379                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1380                  case $extn in                  case $extn in
1381                      F)                      F)
1382                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 1348  EXE_FTL=$EXECUTABLE"_ftl" Line 1434  EXE_FTL=$EXECUTABLE"_ftl"
1434  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1435    
1436  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1437    #
1438    # OPTFILE="$OPTFILE"
1439  #  #
1440  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1441  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1381  EXE_AD      = ${EXE_AD} Line 1469  EXE_AD      = ${EXE_AD}
1469  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1470  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1471    
1472    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1473    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1474    
1475    # These files are created by Makefile
1476    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1477    
1478  EOF  EOF
1479    
1480  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1445  cat >>$MAKEFILE <<EOF Line 1539  cat >>$MAKEFILE <<EOF
1539  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1540    
1541  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1542  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1543            @echo Creating \$@ ...
1544          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1545  depend:  depend:
1546          @make links          @make links
1547          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1548          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1549    
1550  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1551    
1552  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1553    
# Line 1461  output.txt: \$(EXECUTABLE) Line 1556  output.txt: \$(EXECUTABLE)
1556          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1557    
1558  clean:  clean:
1559          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1560  Clean:  Clean:
1561          @make clean          @make clean
1562          @make cleanlinks          @make cleanlinks
1563          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1564            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1565  CLEAN:  CLEAN:
1566          @make Clean          @make Clean
1567          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1476  CLEAN: Line 1571  CLEAN:
1571    
1572  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1573  makefile:  makefile:
1574          ${0} $@          $THIS_SCRIPT $@
1575  cleanlinks:  cleanlinks:
1576          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1577    
1578    # Special targets ($SPECIAL_FILES) which are create by make
1579    ${PACKAGES_DOT_H}:
1580            @echo Creating \$@ ...
1581            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1582    AD_CONFIG.h:
1583            @echo Creating \$@ ...
1584            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1585    FC_NAMEMANGLE.h:
1586            @echo Creating \$@ ...
1587            echo "$FC_NAMEMANGLE" > \$@
1588    
1589  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1590  .F.f:  .F.f:
1591          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1539  adtaf: ad_taf_output.f Line 1645  adtaf: ad_taf_output.f
1645  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1646    
1647  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1648            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1649          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1650            -rm -f ad_config.template
1651          @make \$(F77FILES)          @make \$(F77FILES)
1652          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1653          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1654    
1655  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1656          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1657          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1658    
1659  adtafonly:  adtafonly:
1660          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1661          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1662    
1663  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1664          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1665    
1666  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1667          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1668          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1669    
1670  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1671          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1569  ftltaf: ftl_taf_output.f Line 1677  ftltaf: ftl_taf_output.f
1677  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1678    
1679  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1680            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1681          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1682            -rm -f ftl_config.template
1683          @make \$(F77FILES)          @make \$(F77FILES)
1684          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1685          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1686    
1687  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1688          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1689          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1690    
1691  ftltafonly:  ftltafonly:
1692          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1693          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1694    
1695  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1696          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1697    
1698  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1699          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1700          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1701    
1702  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1703          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
# Line 1639  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1749  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1749    
1750  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1751    
1752  #  Write the "template" files for the adjoint builds  # Create special header files
1753  cat >AD_CONFIG.template <<EOF  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1754  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1755  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1756  C    unless you are CERTAIN that you know what you are doing.  else
1757        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1758  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1759  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1760  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1761  EOF      else
1762  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1763  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1764  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1765  C    unless you are CERTAIN that you know what you are doing.  fi
1766    if test ! -f AD_CONFIG.h ; then
1767  #define ALLOW_ADJOINT_RUN      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1768  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1769    
1770    
1771  #  Write the "state" for future records  #  Write the "state" for future records

Legend:
Removed from v.1.40  
changed lines
  Added in v.1.62

  ViewVC Help
Powered by ViewVC 1.1.22